'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _queue = require('./queue');

var _queue2 = _interopRequireDefault(_queue);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// Types
var defaultOptions = {
  keepRequestsInMemoryWhileConnecting: false // /!\ if set to true, may cause memory overflow
};

var NotifmeRabbitMqProducer = function () {
  function NotifmeRabbitMqProducer() {
    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
    (0, _classCallCheck3.default)(this, NotifmeRabbitMqProducer);
    var keepRequestsInMemoryWhileConnecting = options.keepRequestsInMemoryWhileConnecting,
        queueOptions = (0, _objectWithoutProperties3.default)(options, ['keepRequestsInMemoryWhileConnecting']);

    this.options = (0, _extends3.default)({}, defaultOptions, keepRequestsInMemoryWhileConnecting ? { keepRequestsInMemoryWhileConnecting: keepRequestsInMemoryWhileConnecting } : null);
    this.queue = new _queue2.default((0, _extends3.default)({}, queueOptions));
  }

  (0, _createClass3.default)(NotifmeRabbitMqProducer, [{
    key: 'enqueueNotification',
    value: function () {
      var _ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee(request) {
        var keepRequestsInMemoryWhileConnecting;
        return _regenerator2.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                keepRequestsInMemoryWhileConnecting = this.options.keepRequestsInMemoryWhileConnecting;

                if (!(this.queue.connecting && !keepRequestsInMemoryWhileConnecting)) {
                  _context.next = 5;
                  break;
                }

                throw new Error('[RabbitMQ] Queue is not ready yet. Please retry later.');

              case 5:
                _context.next = 7;
                return this.queue.sendToQueue(request);

              case 7:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function enqueueNotification(_x2) {
        return _ref.apply(this, arguments);
      }

      return enqueueNotification;
    }()
  }]);
  return NotifmeRabbitMqProducer;
}();

exports.default = NotifmeRabbitMqProducer;