'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _stringify = require('babel-runtime/core-js/json/stringify');

var _stringify2 = _interopRequireDefault(_stringify);

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _amqplib = require('amqplib');

var _amqplib2 = _interopRequireDefault(_amqplib);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var defaultOptions = {
  url: 'amqp://localhost',
  amqpOptions: {},
  queueName: 'notifme:request',
  isPersistent: true,
  reconnectDelaySecond: 30
};

var RabbitMqQueue = function () {
  function RabbitMqQueue() {
    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
    (0, _classCallCheck3.default)(this, RabbitMqQueue);
    this.connecting = true;
    this.consumers = {};

    this.options = (0, _extends3.default)({}, defaultOptions, options);
    this.channelPromise = this.connect();
  }

  (0, _createClass3.default)(RabbitMqQueue, [{
    key: 'connect',
    value: function () {
      var _ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee() {
        var _this = this;

        var _options, url, amqpOptions, reconnectDelaySecond, connection;

        return _regenerator2.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _options = this.options, url = _options.url, amqpOptions = _options.amqpOptions, reconnectDelaySecond = _options.reconnectDelaySecond;
                _context.prev = 1;
                _context.next = 4;
                return _amqplib2.default.connect(url, amqpOptions);

              case 4:
                connection = _context.sent;

                connection.on('error', function () {
                  return _this.reconnect();
                });
                connection.on('close', function () {
                  return _this.reconnect();
                });

                console.log('[RabbitMQ] Connection successful.');
                this.connecting = false;
                return _context.abrupt('return', connection.createChannel());

              case 12:
                _context.prev = 12;
                _context.t0 = _context['catch'](1);

                console.error('[RabbitMQ] Connection error. Retry in ' + String(reconnectDelaySecond) + ' seconds.');
                _context.next = 17;
                return sleep(reconnectDelaySecond);

              case 17:
                return _context.abrupt('return', this.connect());

              case 18:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this, [[1, 12]]);
      }));

      function connect() {
        return _ref.apply(this, arguments);
      }

      return connect;
    }()
  }, {
    key: 'reconnect',
    value: function () {
      var _ref2 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee2() {
        var _this2 = this;

        return _regenerator2.default.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                this.connecting = true;
                this.channelPromise = this.connect();
                _context2.next = 4;
                return this.channelPromise;

              case 4:
                (0, _keys2.default)(this.consumers).forEach(function (queueName) {
                  _this2.consumers[queueName].forEach(function (consumer) {
                    _this2.consume(queueName, consumer);
                  });
                });

              case 5:
              case 'end':
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function reconnect() {
        return _ref2.apply(this, arguments);
      }

      return reconnect;
    }()
  }, {
    key: 'consume',
    value: function () {
      var _ref3 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee4(queueName, callback) {
        var _this3 = this;

        var isPersistent, channel;
        return _regenerator2.default.wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                isPersistent = this.options.isPersistent;
                _context4.next = 3;
                return this.channelPromise;

              case 3:
                channel = _context4.sent;
                _context4.next = 6;
                return channel.assertQueue(queueName, { durable: isPersistent });

              case 6:
                _context4.next = 8;
                return channel.prefetch(1);

              case 8:
                return _context4.abrupt('return', channel.consume(queueName, function () {
                  var _ref4 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee3(message) {
                    return _regenerator2.default.wrap(function _callee3$(_context3) {
                      while (1) {
                        switch (_context3.prev = _context3.next) {
                          case 0:
                            if (!(message !== null)) {
                              _context3.next = 4;
                              break;
                            }

                            _context3.next = 3;
                            return callback(JSON.parse(message.content.toString()));

                          case 3:
                            channel.ack(message);

                          case 4:
                          case 'end':
                            return _context3.stop();
                        }
                      }
                    }, _callee3, _this3);
                  }));

                  return function (_x4) {
                    return _ref4.apply(this, arguments);
                  };
                }(), { noAck: !isPersistent }));

              case 9:
              case 'end':
                return _context4.stop();
            }
          }
        }, _callee4, this);
      }));

      function consume(_x2, _x3) {
        return _ref3.apply(this, arguments);
      }

      return consume;
    }()
  }, {
    key: 'registerConsumer',
    value: function () {
      var _ref5 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee5(callback) {
        var queueName;
        return _regenerator2.default.wrap(function _callee5$(_context5) {
          while (1) {
            switch (_context5.prev = _context5.next) {
              case 0:
                queueName = this.options.queueName;

                if (!this.consumers[queueName]) {
                  this.consumers[queueName] = [];
                }
                this.consumers[queueName].push(callback);
                return _context5.abrupt('return', this.consume(queueName, callback));

              case 4:
              case 'end':
                return _context5.stop();
            }
          }
        }, _callee5, this);
      }));

      function registerConsumer(_x5) {
        return _ref5.apply(this, arguments);
      }

      return registerConsumer;
    }()
  }, {
    key: 'sendToQueue',
    value: function () {
      var _ref6 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee6(request) {
        var _options2, queueName, isPersistent, channel;

        return _regenerator2.default.wrap(function _callee6$(_context6) {
          while (1) {
            switch (_context6.prev = _context6.next) {
              case 0:
                _options2 = this.options, queueName = _options2.queueName, isPersistent = _options2.isPersistent;
                _context6.next = 3;
                return this.channelPromise;

              case 3:
                channel = _context6.sent;
                _context6.next = 6;
                return channel.assertQueue(queueName, { durable: isPersistent });

              case 6:
                return _context6.abrupt('return', channel.sendToQueue(queueName, Buffer.from((0, _stringify2.default)(request)), { persistent: isPersistent }));

              case 7:
              case 'end':
                return _context6.stop();
            }
          }
        }, _callee6, this);
      }));

      function sendToQueue(_x6) {
        return _ref6.apply(this, arguments);
      }

      return sendToQueue;
    }()
  }]);
  return RabbitMqQueue;
}();

exports.default = RabbitMqQueue;


function sleep(second) {
  return new _promise2.default(function (resolve) {
    return setTimeout(resolve, second * 1000);
  });
}